%!
% This is the basic.pro for use by dvi2ps version 3.1
%
% Original version by:	Neal Holtz, Carleton University, Ottawa, Canada
%			<holtz@cascade.carleton.cdn>
%			<holtz%cascade.carleton.cdn@ubc.csnet>
%			June, 1985
% Modifications by:	oystr		12-Feb-86
%			jr@bbn.com	18-May-87
%			mackay		 4-Jan-88
% Seriously hacked by:	Van Jacobson, LBL
%			<van@lbl-csam.arpa>
% This version by:	Kevin Coombes, University of Michiogan
%			<kevin@math.lsa.umich.edu>
%			<Kevin_Coombes@ub.cc.umich.edu>
%
% All procedures used directly by dvi2ps either begin with the character '@'
% or have short names (p, r, s, m, c, ru). Additional procedures used in
% order to implement the direct procedures have names which more closely 
% follow the standard PostScript conventions. Dvi2ps should not emit any
% unmonitored postscript code, except when copying a file included by a 
% TeX \special command.
%
% To convert this file into a downloaded file instead of a header
% file, uncomment all of the lines beginning with %-%

%-%0000000 			% Server loop exit password
%-%serverdict begin exitserver
%-%  systemdict /statusdict known
%-%  {statusdict begin 9 0 3 setsccinteractive /waittimeout 300 def end}
%-% if

/TeXDict 200 dict def		% Initialize a dictionary.
TeXDict begin			% Start using it.
/Mtrx matrix def		% Provide storage to save currentmatrix.
% This is necessary because dvi2ps outputs coordinates in the standard TeX
% system, with origin [0, 0] at 1" down and in from the top left, with the
% positive y direction extending downward, while the PostScript default has
% the origin at the bottom left corner with the positive y direction extending
% upward. See also the note with the command startdoc.

%%%%%%%%%%%%%%%%%%%%%%%%%%% Preliminaries %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% - @start -			% Must be the first command output by dvi2ps
/@start {
    /StartTime usertime def
    vmstatus pop /@VMused exch def pop 
    72 720 translate 
} def

%%%%%%%%%%%%%%%%%%%%%%%%%%% User Options %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% The following commands are optional. If they appear, they must immediately 
% follow the start command, and precede the required startdoc command.

% - @letter -
/@letter { /letter where { pop letter 72 720 translate } if } def

% - @legal -
/@legal { /legal where { pop legal 72 936 translate } if } def

% - @note -
/@note { /note where { pop note 72 720 translate } if } def

% - @a4 -
/@a4 { /a4 where { pop a4 72 765 translate } if } def

% - @landscape -
/@landscape { [ 0 1 -1 0 0 0 ] concat 72 -72 translate } def
% Note: 90 rotate doesn't work because (at least on ALW) cos(90) != 0

% - @manualfeed -
/@manualfeed { /manualfeed where { /manualfeed true put } if } def

% - @duplex -
/@duplex { /setduplexmode where { /setduplexmode true put } if } def

% number @copies -
/@copies { /#copies exch def } def

% The other user options, @draft and @twoup, affect the page setting 
% options more directly, so the definitions are deferred.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% End user options %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This is a REQUIRED command. Note that the origin has already been translated
% to the preferred TeX origin by an earlier command. Since the output of dvi2ps
% is in "dots", we have to rescale. The default of 300 dpi can be overridden
% by the user, and is sent as a parameter to @startdoc.
% resolution @startdoc -	
/@startdoc {
	dup				% Save resolution for reuse.
	72 exch div dup neg scale		% Rescale and redirect axes.
	0 0 transform round exch round exch itransform translate
% This magic is intended to avoid device dependent irregularities, by realigning
% the coordinate axes along pixel boundaries. This is of particular importance
% in landscape mode. The standard TeX page setup is then stored and saved.
	Mtrx currentmatrix pop
	currentdict /isoddpage known	% Only defined if printing twoup.
	{   /SecondMtrx matrix def
	    8.5 exch mul 0 translate	% Magic number---default pagewidth 8.5in.
	    SecondMtrx currentmatrix pop
	}{
	    pop
	} ifelse
	/@TeXSave save def
} def

/@restore /restore load def

/restore {
   vmstatus pop
   dup @VMused lt {pop @VMused} if	 % calculate virtual memory used
   exch pop exch @restore /@VMused exch def
} bind def

/@pri { ( ) print
    (                                       ) cvs print
}def

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% End preliminaries %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%% TeX font management %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% If dvi2ps cannot find the desired font at the correct size and magnification
% requested in the dvi file, it substitutes another available size and uses
% PostScript to scale it appropriately. This scale factor is the first parameter
% to @newfont.
% scale name @newfont -		% Initialize a new font dictionary.
/@newfont {
    /newname exch def
    newname 7 dict def
    newname load begin
        /FontType 3 def
        dup neg matrix scale /FontMatrix exch def
        /FontBBox [0 0 1 1] def
        /BitMaps 256 array def
        /BuildChar {CharBuilder} def
        /Encoding 256 array def
        0 1 255 {Encoding exch /.undef put} for
        end
    newname newname load definefont pop
} bind def

% The following is the only character builder we need.  It looks up the
% char data in the BitMaps array, and paints the character if possible.
% Here char data  -- a bitmap descriptor -- is an array of length 6, of 
% which the various slots are:
/ch-image  {ch-data 0 get} bind def	% the hex string image,
/ch-width  {ch-data 1 get} bind def	% the number of pixels across,
/ch-height {ch-data 2 get} bind def	% the number of pixels tall,
/ch-xoff   {ch-data 3 get} bind def	% number of pixels below origin,
/ch-yoff   {ch-data 4 get} bind def	% number of pixels to left of origin,
/ch-tfmw   {ch-data 5 get} bind def	% spacing to next character.

% fontdict ch CharBuilder -	% Image one character.
/CharBuilder
  { exch /BitMaps get exch get /ch-data exch def
    ch-data null ne {
	ch-tfmw    0     ch-xoff neg     ch-yoff neg
	ch-width ch-xoff sub   ch-height ch-yoff sub
      setcachedevice
	ch-width ch-height true [1 0  0 1 ch-xoff ch-yoff] {ch-image}
      imagemask
    } if
} bind def

% The font-cacheing mechanism requires that a name unique in the particular
% font be generated. This is simply done using the character code itself.
% char-data ch @dc -		% Define a new character bitmap.
/@dc{
    /ch-code exch def
    dup 0 get
    length 2 lt
      { pop [ <00> 1 1 0 0 8.00 ] } % replace <> with null
% Wolczko: {dup 4 get exch 5 get <00> 1 1 0 6 -2 roll 6 array astore}
    if
    /ch-data exch def
    currentfont /BitMaps get ch-code ch-data put
    currentfont /Encoding get ch-code dup (   ) cvs cvn put
} bind def

% char-data ch @pc -    -- print a character bitmap not downloaded
/@pc {
    pop
    /ch-data exch def
    currentpoint translate
      ch-width ch-height true [1 0 0 -1 ch-xoff ch-yoff ] {ch-image}
    imagemask
} bind def

% fontdict @sf -		% Make that the current font.
/@sf { setfont } def

% - @flushfonts -		% Recover virtual memory by deleting font info.
/@flushfonts { @TeXSave restore /@TeXSave save def} def
%%%%%%%%%%%%%%%%%%%%%%%%%% End TeX font management %%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%% Basic page setting %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% The next set of procedures are the principal typesetting commands output by
% dvi2ps itself, as opposed to any specials.

% n @bop0 -			% begin the char def section of a new page
/@bop0 { pop } bind def

% n @bop1 -			% begin a brand new page
/@bop1 { pop Mtrx setmatrix /SaveImage save def } def

% - @eop -			% end a page
/@eop { showpage SaveImage restore } def

% x y p -			% move to position
/p { moveto } bind def

% x r -				% move right
/r { 0 rmoveto } bind def

% string s -			% show the string
/s { show pop } bind def

% mark string int string int ... int string ks -
% Based on kernshow in the green book; intended to speed up
% processing of repeated small movements.
/ks {
    2 1 counttomark 2 sub { -1 roll } for	% reverse stack order
    counttomark 2 idiv {
	show 0 rmoveto
    } repeat
    show					% the last text string
    pop						% delete the mark
} bind def

% - m -				% mark
/m { mark } bind def

% ch c -			% show the character (code given)
%/c { c-string dup 0 4 -1 roll put show } bind def

%/c-string ( ) def

% dx dy ru -			% set a rule (rectangle)
/ru {
    /dy exch 1 sub neg def	% because dy is height up from bottom
    /dx exch 1 sub def
    gsave
    currentpoint
    newpath moveto
    dx 0 rlineto
    0 dy rlineto
    dx neg 0 rlineto
    closepath fill
    grestore
} bind def

% - @end -			% done the whole shebang
/@end {
   (Time used: ) print usertime StartTime sub @pri
   (VM used: ) print @VMused @pri
   (. Unused: ) print vmstatus @VMused sub @pri pop pop
   (\n) print flush
   end 
} def
%%%%%%%%%%%%%%%%%%%%%%%%%% End basic page setting %%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Other options %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/DraftFirst { gsave initmatrix newpath
       /Helvetica-Bold findfont setfont
       (Draft) dup stringwidth pop 8.875 exch div dup 72 mul dup scale
       52.3 rotate 2.5 exch div -.35 translate
       0.95 setgray
       0 0 moveto show
       grestore
} bind def

/DraftMore { gsave initmatrix newpath
       /Helvetica-Bold findfont 72 scalefont setfont
       0.95 setgray
       576 702 moveto
       (Draft) stringwidth exch neg exch neg rmoveto
       (Draft) show
       grestore 
} bind def

/@draft {
	/@bop1 { 1 le {DraftFirst} {DraftMore} ifelse
	    Mtrx setmatrix
	    /SaveImage save def
	} bind def
} bind def

/@twoup {
	initmatrix [ 0 1 -1 0 0 0 ] concat
	36 -87 translate  5.5 8.5 div dup scale
	/isoddpage true def
	/@eop { isoddpage not {showpage} if
		SaveImage restore
		/isoddpage isoddpage not def
	} def
	/@bop1 { pop 
		isoddpage
		  { SecondMtrx setmatrix }
		  { Mtrx setmatrix }
		ifelse
		/SaveImage save def
	} def
	/@end { isoddpage not { showpage } if
		end
	} def
} def
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% End other options %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Special command %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/@beginspecial
  { SpecialDict begin
    gsave /SpecialSave save def
    currentpoint transform initgraphics itransform translate 0 0 moveto
    SpecialDefaults
    IfMacSetUp
  } def

/@setspecial
  {
    hof vof translate setclipper
    hsc vsc scale
    angl rotate
  } def

/@endspecial
  { SpecialSave restore
    grestore end
  } def

/@beginfullpage {
    gsave /SpecialSave save def
    SpecialDict begin
    /showpage {} def
    initgraphics
} def

/@endfullpage {
    clear end SpecialSave restore grestore showpage
} def

/SpecialDict 50 dict def
SpecialDict begin
/Inch { 72 mul} bind def

/SpecialDefaults
  { /hsi 8.5 Inch def
    /vsi 11 Inch def
    /hof 0 def
    /vof 0 def
    /hsc 1 def
    /vsc 1 def
    /angl 0 def
    /CLIP false def
  } def
/@hsize {/hsi exch def /CLIP true def} def
/@vsize {/vsi exch def /CLIP true def} def
/@hoffset {/hof exch def} def
/@voffset {/vof exch def} def
/@hscale {/hsc exch def} def
/@vscale {/vsc exch def} def
/@rotate {/angl exch def} def

/setclipper
  {
    CLIP
      { newpath 0 0 moveto hsi 0 rlineto 0 vsi rlineto hsi neg 0 rlineto 
	closepath clip }
    if
  } def
end	%SpecialDict

% We test to see if the Mac LaserPrep file has been loaded. If we think it has
% been loaded, we turn-off or fix-up all the MacDraw stuff that might hurt us.

% - IfMacSetUp -   
/IfMacSetUp
  { userdict /md known				% If md is defined
      { userdict /md get type /dicttype eq      % and if it is a dictionary,
	 { md begin                             % then redefine some stuff.
	      /txpose{
		 1 -1 scale  % make y coordinates relative to top of figure
	      } bind def
              /cp {pop pop} bind def
           end }
        if }
    if    
  } def
%%%%%%%%%%%%%%%%%%%%%%%%%%% End special command %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

end        % TeXDict   and revert to previous dictionary
